import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;

/*
 * FileChooserDemo.java is a 1.4 application that uses these files:
 *   images/Open16.gif
 *   images/Save16.gif
 */
public class FileChooserEnviar extends JPanel
                             implements ActionListener {
    static private final String newline = "\n";
    JButton enviar;
    JTextArea log;
    JFileChooser fc;
    JTextField host,puerto;
    
    public static final int LARGO_BUFFER = 512;
    public static byte[] buffer = new byte[1];
    

    public FileChooserEnviar() {
        super(new BorderLayout());

        //Create the log first, because the action listeners
        //need to refer to it.
        host = new JTextField("localhost",20);
        puerto = new JTextField("7000",5);
        log = new JTextArea(5,50);
        log.setMargin(new Insets(5,5,5,5));
        log.setEditable(false);
        JScrollPane logScrollPane = new JScrollPane(log);
		
		//Create a file chooser
        fc = new JFileChooser();

        fc.setFileSelectionMode(JFileChooser.FILES_ONLY); //viene por default
        
        enviar = new JButton("Enviar Archivo...",new ImageIcon("Open16.gif"));
                                 //createImageIcon("Open16.gif"));
        enviar.addActionListener(this);

        

        //For layout purposes, put the buttons in a separate panel
        JPanel buttonPanel = new JPanel(); //use FlowLayout
        buttonPanel.add(new JLabel("host"));
        buttonPanel.add(host);
        buttonPanel.add(new JLabel("puerto"));
        buttonPanel.add(puerto);
        buttonPanel.add(enviar);
        

        //Add the buttons and the log to this panel.
        add(buttonPanel, BorderLayout.PAGE_START);
        add(logScrollPane, BorderLayout.CENTER);
    }

    public void actionPerformed(ActionEvent e) {

        //Handle open button action.
        if (e.getSource() == enviar) {
        	
        	int returnVal = fc.showOpenDialog(FileChooserEnviar.this);

            if (returnVal == JFileChooser.APPROVE_OPTION) {
                File file = fc.getSelectedFile();
                //This is where a real application would open the file.
                log.append("Enviando: " + file.getName() + "." + newline);
                 
        	try{
        	
        		Socket s=new Socket(	host.getText().trim(),
        								Integer.parseInt(puerto.getText().trim())
        							);	
		 		  	  
				String linea;
				  
				System.out.println("enviando el nombre");  
				PrintWriter pwSocket = new PrintWriter(s.getOutputStream(),true);
				pwSocket.println(file.getName().trim()); //envio el nombre del archivo primero
				
				System.out.println("nombre enviado");
					
				  	
				BufferedOutputStream escribeFile = new BufferedOutputStream(s.getOutputStream());
				FileInputStream leeFile = new FileInputStream(file);
				 
				 
	        	byte[] buffer = new byte[LARGO_BUFFER];
	        	System.out.println("entrando ciclo de escritura");
	            while (leeFile.available()>0)
	            	escribeFile.write(buffer, 0, leeFile.read(buffer));
	            System.out.println("saliendo ciclo de escritura");
	            escribeFile.flush();
	            
	            log.append("[ Enviado ]"+newline);
	            
	            escribeFile.close();
	            leeFile.close();
	            pwSocket.close();
	         	s.close();
				  
			}
			catch(UnknownHostException uhe){
			  log.append("computador desconocido"+newline);
			}
			catch(ConnectException ce){
			  log.append("Conexin fallida: nadie escucha"+newline);
			}
			catch(IOException ioex){
			  log.append("Error de Escritura Sockets"+newline);
			}
			catch(NumberFormatException nfe){
			  log.append("Numero de puerto no es VALIDO"+newline );
			}
					
		} 
		
		else {
	    	log.append("Abrir archivo cancelado por el usuario." + newline);
	  	}
	    
	    log.append("------------------------------------------------" + newline);
	    log.setCaretPosition(log.getDocument().getLength());
		
		}            

            
               
    }

    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = FileChooserEnviar.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);
        JDialog.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
        JFrame frame = new JFrame("Enviar Archivo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        JComponent newContentPane = new FileChooserEnviar();
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);

        //Display the window.
        //frame.pack();
        frame.setSize(600,600);
        frame.setVisible(true);
    }
    
    private static void sendFile(FileInputStream lee, BufferedOutputStream escribe){
	        try {
	            byte[] buffer = new byte[LARGO_BUFFER];
	            while (lee.available()>0)
	                escribe.write(buffer, 0, lee.read(buffer));
	            escribe.flush();
	            
	        } 
	        
	        catch (IOException e) { System.err.println(e); }
	}

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
