import java.net.*;
import java.io.*;

public class MandarFile{
	
	public static final byte NO_EXISTE = 1;
    public static final byte NO_FILE= 2;
    public static final byte NO_LEE= 3;
    public static final byte OK = 0;
    public static final int LARGO_BUFFER = 512;
    public static byte[] buffer = new byte[1];
    
    
	
	public static void main(String[]args)throws IOException{
		
		if(args[0]==null){
		  System.out.println("Uso: java Recibir port"); 
		  System.exit(0);
		}
		
		try{
			
		  ServerSocket ss=new ServerSocket(Integer.parseInt(args[0]));
		  Socket s; 
		  
		  	  
		  String linea="";
		  BufferedReader buf;
		  
		   
		  inicio:while(true){
		  	
		  	s = ss.accept(); 
		  	
		  	buf= new BufferedReader(new InputStreamReader(s.getInputStream()));
		  	BufferedOutputStream escribeFile = new BufferedOutputStream(s.getOutputStream());
		  	File file;
		  	
			while(true){
				
				linea=buf.readLine();
			  	if(linea==null) continue inicio;
			  	
			  	System.out.println("Solicitando el Archivo: "+linea);
			  	
			  	file = new File(linea);		  	
			  	
			  	boolean ok=true;
			  	
			  	if(!file.exists()){ 
			  		System.out.println("ERROR: Archivo no Existe");
			  		buffer[0]=NO_EXISTE;
			  		ok=false;
			  	}
			  	
			  	else if(!file.isFile()){ 
			  		System.out.println("EERROR: Solitando un directorio!");
			  		buffer[0]=NO_FILE;
			  		ok=false;
			  	}
			  	
			  	else if(!file.canRead()){ 
			  		System.out.println("ERROR: Archivo no tiene permisos de Lectura");
			  		buffer[0]=NO_LEE;
			  		ok=false;
			  	}
			  	
			  	
			  	if(!ok){	
			  		System.out.println(" ");
			  		System.out.println("------------------------------------------- ");
			  		escribeFile.write(buffer,0,1);
			  		escribeFile.flush();
			  		continue;
			  	}
			  	else break;
			  }
		  
		  	
		  	
		  	//Existe el archivo. A mandarlo!
		  	buffer[0]=OK;
		  	escribeFile.write(buffer,0,1);
		  	escribeFile.flush();
		  	
		  	
		  	
		  	FileInputStream leeFile = new FileInputStream(file);
		  	
		  	sendFile(leeFile,escribeFile);
		  	
		  	
		  	escribeFile.close();
		  	leeFile.close();
		  	buf.close();
		  	System.out.println("Archivo Enviado");
		  	System.out.println(" ");
		  	System.out.println("------------------------------------------- ");
		 	
		  }
		  
				  
		}
		
		catch(BindException e){
		  System.out.println("port no se puede usar o est ocupado");
		}
		
		catch(FileNotFoundException fnfe){
		  System.out.println("no se encuentra ese archivo");
		}
	}


	private static void sendFile(FileInputStream lee, BufferedOutputStream escribe){
	        try {
	            byte[] buffer = new byte[LARGO_BUFFER];
	            while (lee.available()>0)
	                escribe.write(buffer, 0, lee.read(buffer));
	            escribe.flush();
	            
	        } 
	        
	        catch (IOException e) { System.err.println(e); }
	}
}