import java.net.*;
import java.io.*;


public class PedirFile{
	
	public static final byte NO_EXISTE = 1;
    public static final byte NO_FILE= 2;
    public static final byte NO_LEE= 3;
    public static final byte OK = 0;
 	public static final int LARGO_BUFFER = 512;
	
	public static void main(String[]args){
		
		if(args.length < 2 ){
		  System.out.println("Uso: java PedirFile comp port"); 
		  System.exit(0);
		}
		
		try{
			
		  Socket s=new Socket(args[0],Integer.parseInt(args[1]));
		 		  	  
		  String linea;
		  BufferedReader bufTeclado = new BufferedReader(new InputStreamReader(System.in));
		  PrintWriter pwSocket = new PrintWriter(s.getOutputStream(),true);
		  BufferedInputStream leeFile = new BufferedInputStream(s.getInputStream());
		  	  
		  System.out.print("Archivo a Solicitar: ");	  
		  		
		  while((linea=bufTeclado.readLine())!=null && !linea.equalsIgnoreCase("salir")){
		  	
		  	pwSocket.println(linea);
		  	
		  	String nombre = linea.substring(linea.lastIndexOf("/")+1);
		  			  	
		  	byte[] buffer = new byte[1];
		  	
		  	if(leeFile.read(buffer,0,1)> 0 ){
		  		
		  		boolean ok = true;
		  		
		  		if(buffer[0]==NO_EXISTE){
		  			System.out.println("ERROR: Archivo no Existe");
		  			ok=false;
		  		}
		  		if(buffer[0]==NO_FILE){
		  			System.out.println("ERROR: Solitando un directorio!");
		  			ok=false;
		  		}
		  			
		  		if(buffer[0]==NO_LEE){
		  			System.out.println("ERROR: Archivo no tiene permisos de Lectura");
		  			ok=false;
		  		}
		  		
		  		if(!ok){
			  		System.out.println(" ");
			  		System.out.println("------------------------------------------- ");
			  		System.out.println(" ");
			  		System.out.print("Archivo a Solicitar: ");	  
			  		continue;
			  	}
		  	}
		  	
		  	if(buffer[0]==OK) System.out.println("Archivo Encontrado");
		  	else continue;
		  	
		  	
		  	File file= new File(nombre);
		  			  	
		  	FileOutputStream escribeFile = new FileOutputStream(file);
			
			buffer = new byte[1000];
			int c;
			int totalBytes=0;
			
			while( (c=leeFile.read(buffer,0,LARGO_BUFFER) ) > 0 ){
				escribeFile.write(buffer,0,c);
				totalBytes+=c;
			}
	        System.out.println("Bytes leidos: "+totalBytes);		
	        leeFile.close();
		    escribeFile.close();	
		    
		    System.out.println("[ Recibido ]");
		    System.out.println(" ");	  
		    System.out.println("------------------------------------------- ");
		    System.out.println(" ");
		    System.out.print("Archivo a Solicitar: ");	  
		    
		  }
		  
		  
		  s.close();
		  bufTeclado.close();
		  pwSocket.close();
		  
		  
		  
		}
		catch(UnknownHostException e){
		  System.out.println("computador desconocido");
		}
		catch(ConnectException e){
		  System.out.println("Conexin fallida: nadie escucha");
		}
		catch(IOException ioex){
		  System.out.println("Error de Escritura Sockets");
		}	
		
			
	}
}

 
 /*	 EJEMPLOS DE USO:
 en una ventanda cd DOS:  java MandarFile 7654
 queda corriendo.
 
 en otra ventana de DOC:  java PedirFile localhost 7654
 Archivo a solicitar:  a.txt
 Bytes leidos: 16
 -- Recibido --
 
 Archivo a solicitar:  salir
 
 */