import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;

/*
 * FileChooserDemo.java is a 1.4 application that uses these files:
 *   images/Open16.gif
 *   images/Save16.gif
 */
public class RecibirServer extends JPanel
                             implements ActionListener {
    static private final String newline = "\n";
    JButton Iniciar_Servidor;
    JTextArea log;
    JTextField puerto;
    
    public static final int LARGO_BUFFER = 512;
    public static byte[] buffer = new byte[1];
    

    public RecibirServer() {
        super(new BorderLayout());

        //Create the log first, because the action listeners
        //need to refer to it.
        puerto = new JTextField("7000",5);
        log = new JTextArea(5,50);
        log.setMargin(new Insets(5,5,5,5));
        log.setEditable(false);
        JScrollPane logScrollPane = new JScrollPane(log);
		
	    Iniciar_Servidor = new JButton("Iniciar Recepcion...",new ImageIcon("Open16.gif"));
                                 
        Iniciar_Servidor.addActionListener(this);

        

        //For layout purposes, put the buttons in a separate panel
        JPanel buttonPanel = new JPanel(); //use FlowLayout
        buttonPanel.add(new JLabel("puerto"));
        buttonPanel.add(puerto);
        buttonPanel.add(Iniciar_Servidor);
        

        //Add the buttons and the log to this panel.
        add(buttonPanel, BorderLayout.PAGE_START);
        add(logScrollPane, BorderLayout.CENTER);
    }

    public void actionPerformed(ActionEvent e) {

        //Handle open button action.
        if (e.getSource() == Iniciar_Servidor) {
        	
            
        	try{
        		ServerSocket ss=new ServerSocket(Integer.parseInt(puerto.getText()));
		  		Socket s; 	
        		
        	//	while(true){
		  			
		  	
				  	s = ss.accept(); 
				  	
				  	BufferedReader buf= new BufferedReader(new InputStreamReader(s.getInputStream()));
				  	File file;
				  	String linea,nombre;
				  	
					while(true){ //esperamos por el nombre del archivo
						linea=buf.readLine();
					  	if(linea!=null) {
					  		System.out.println("nombre completo: "+linea);
					  		nombre = linea.substring(linea.lastIndexOf("/")+1);
					  		file = new File(nombre);
					  		//buf.close();
					  		break;					  	
					    }
					}
					
				System.out.println("ya tenemos el nombre: "+file.getName());  	
				
					if(!file.canWrite()){ 
						System.out.println("ERROR: no podemos escribir");  	
						return;
					}
				
					log.append("Recibiendo el Archivo: "+linea+newline);
					
					BufferedInputStream leeFile = new BufferedInputStream(s.getInputStream());
				  	FileOutputStream escribeFile = new FileOutputStream(file);
			
					buffer = new byte[LARGO_BUFFER];
					int c;
					int totalBytes=0;
					
					
				System.out.println("entrando al ciclo de lectura del archivo");	
				
				
					while( (c=leeFile.read(buffer,0,LARGO_BUFFER) ) > 0 ){
						escribeFile.write(buffer,0,c);
						totalBytes+=c;
					}
			        escribeFile.flush();
			        
			       System.out.println("saliendo ciclo de lectura");
			        
			        log.append("Bytes leidos: "+totalBytes+newline);		
			        
			        
			        leeFile.close();
				    escribeFile.close();
				    buf.close();
				    s.close();	
				   
				    
				    log.append("[ Recibido ]"+newline);
				    log.append("------------------------------------------------" + newline);
	    			log.setCaretPosition(log.getDocument().getLength());
				    
				    
		    //	}		  
				  
			}
		
			/*catch(InterruptedException ie){
		  		;
			}*/
			catch(BindException be){
		  		System.out.println("port no se puede usar o esta ocupado");
		  		log.append("------------------------------------------------" + newline);
	    		log.setCaretPosition(log.getDocument().getLength());
			}
			catch(IOException ioex){
			  log.append("Error de Conexion Sockets"+newline);
			  log.append("------------------------------------------------" + newline);
	    	  log.setCaretPosition(log.getDocument().getLength());
			}
			catch(NumberFormatException nfe){
			  log.append("Numero de puerto no es VALIDO"+newline );
			  log.append("------------------------------------------------" + newline);
	    	  log.setCaretPosition(log.getDocument().getLength());
			}
					
		} 
		
		            

            
               
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);
        JDialog.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
        JFrame frame = new JFrame("Iniciar_Servidor Archivo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        JComponent newContentPane = new RecibirServer();
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);

        //Display the window.
        //frame.pack();
        frame.setSize(600,600);
        frame.setVisible(true);
    }
    
    private static void sendFile(FileInputStream lee, BufferedOutputStream escribe){
	        try {
	            byte[] buffer = new byte[LARGO_BUFFER];
	            while (lee.available()>0)
	                escribe.write(buffer, 0, lee.read(buffer));
	            escribe.flush();
	            
	        } 
	        
	        catch (IOException e) { System.err.println(e); }
	}

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
